#include <sys/sysinfo.h>
#include <linux/kernel.h>
#include <unistd.h>
#include <stdlib.h>
#include <qfile.h>

/* $Id: memory_linux.cpp,v 1.6 2003/12/22 23:22:10 dstone Exp $ */

void KMemoryWidget::update()
{
  struct sysinfo info;
  
  sysinfo(&info);	/* Get Information from system... */
 
  Memory_Info[TOTAL_MEM]    = MEMORY(info.totalram) * info.mem_unit; // total physical memory (without swaps)
  Memory_Info[FREE_MEM]     = MEMORY(info.freeram) * info.mem_unit; // total free physical memory (without swaps)
  Memory_Info[SHARED_MEM]   = MEMORY(info.sharedram) * info.mem_unit; 
  Memory_Info[BUFFER_MEM]   = MEMORY(info.bufferram) * info.mem_unit; 
  Memory_Info[SWAP_MEM]     = MEMORY(info.totalswap) * info.mem_unit; // total size of all swap-partitions
  Memory_Info[FREESWAP_MEM] = MEMORY(info.freeswap) * info.mem_unit; // free memory in swap-partitions

  
  QFile file("/proc/meminfo");
  if (file.open(IO_ReadOnly)) {
	char buf[512];
	while (file.readLine(buf, sizeof(buf) - 1) > 0) {
		if (strncmp(buf,"Cached:",7)==0) {
			unsigned long v;
			v = strtoul(&buf[7],NULL,10);			
			Memory_Info[CACHED_MEM] = MEMORY(v)*1024; // Cached memory in RAM
		}
	}
	file.close();
  }
}

